<?php

/******************************************************************************************/
/* SPIP-listes est un systme de gestion de listes d'information par email pour SPIP      */
/* Copyright (C) 2004 Vincent CARON  v.caron<at>laposte.net , http://bloog.net            */
/*                                                                                        */
/* Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes */
/* de la Licence Publique Gnrale GNU publie par la Free Software Foundation            */
/* (version 2).                                                                           */
/*                                                                                        */
/* Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE,       */
/* ni explicite ni implicite, y compris les garanties de commercialisation ou             */
/* d'adaptation dans un but spcifique. Reportez-vous  la Licence Publique Gnrale GNU  */
/* pour plus de dtails.                                                                  */
/*                                                                                        */
/* Vous devez avoir reu une copie de la Licence Publique Gnrale GNU                    */
/* en mme temps que ce programme ; si ce n'est pas le cas, crivez  la                  */
/* Free Software Foundation,                                                              */
/* Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.                   */
/******************************************************************************************/


	$GLOBALS['spiplistes_version'] = 1.95;
	function spiplistes_verifier_base(){
		$accepter_visiteurs = lire_meta('accepter_visiteurs');

		if($accepter_visiteurs != 'oui'){
			$accepter_visiteurs = 'oui';
			ecrire_meta("accepter_visiteurs", $accepter_visiteurs);
			ecrire_metas();
			echo _T('spiplistes:autorisation_inscription');
		}
		
		$version_base = $GLOBALS['spiplistes_version'];
		$current_version = 0.0;
		if (   (!isset($GLOBALS['meta']['spiplistes_version']) )
				|| (($current_version = $GLOBALS['meta']['spiplistes_version'])!=$version_base)){
			include_spip('base/spip-listes');
			
			// si etait deja installe mais dans une vieille version, on reprend a zero
			include_spip('base/abstract_sql');
			$desc = spip_abstract_showtable("spip_listes", '', true);
			if (!isset($desc['field']['id_liste']))
				$current_version = 0.0;
			if (
				($res=spip_query("SELECT * FROM spip_articles WHERE statut='liste' OR statut='inact' OR statut='poublist'"))
				AND ($row = spip_fetch_array($res)) )
				$current_version=0.0;

			if ($current_version==0.0){
				// Verifie que les tables spip_listes existent, sinon les creer
				spip_log('creation des tables spip_listes');
				include_spip('base/create');
				include_spip('base/abstract_sql');
				creer_base();
				
				//Mise a jour des listes anciennes // a mettre en fonction
				$resultat_aff = spip_query("SELECT * FROM spip_articles WHERE statut='liste' OR statut='inact' OR statut='poublist'");
				if(@spip_num_rows($resultat_aff) > 0){
					echo "<h3>SPIP-listes va mettre a jour</h3>";
					while ($row = spip_fetch_array($resultat_aff)) {
						$id_article=$row['id_article'];
						$titre_liste=corriger_caracteres($row['titre']);
						$texte_liste = corriger_caracteres($row['texte']);
						$date_liste = $row['date'];
						$langue=$row["lang"];
						$statut = $row['statut'];
						$extra=unserialize($row['extra']);
						$patron_liste=$extra["squelette"];
						$periode_liste=$extra["periode"];
						$maj_liste=$extra["majnouv"];
						$email_envoi=$extra["email_envoi"];
						$message_auto=$extra["auto"];
						$options="<p>".$titre_liste."<br/>";
						echo $options."</p>";
						
						//pied de page
						include_spip('public/assembler');
						$contexte_pied = array('lang'=>$langue);
						$pied = recuperer_fond('modeles/piedmail', $contexte_pied);
						
						spip_query("INSERT INTO spip_listes (titre, texte, statut, date, lang, pied_page) VALUES ("
							._q($titre_liste).","._q($texte_liste).","._q($statut).","._q($date_liste).","._q($langue).","._q($pied).")" );
						$id_liste=spip_insert_id();
						if($message_auto=="oui")
							spip_query("UPDATE spip_listes SET patron="._q($patron_liste).", periode="._q($periode_liste)
							  . ", maj=FROM_UNIXTIME("._q($maj_liste)."), email_envoi="._q($email_envoi)
							  . ", message_auto="._q($message_auto)." WHERE id_liste="._q($id_liste));
						
						//Auteur de la liste (moderateur)
						spip_query("DELETE FROM spip_auteurs_mod_listes WHERE id_liste ="._q($id_liste));
						spip_query("INSERT INTO spip_auteurs_mod_listes (id_auteur, id_liste) VALUES ("._q($connect_id_auteur).","._q($id_liste).")");
						
						//recuperer les abonnes (peut etre plus tard ?)
						$abos=spip_query("SELECT id_auteur, id_article FROM spip_auteurs_articles WHERE id_article="._q($id_article));
						while($abonnes=spip_fetch_array($abos)){
							$abo=$abonnes["id_auteur"];
							spip_query("INSERT INTO spip_auteurs_listes (id_auteur, id_liste) VALUES ("._q($abo).","._q($id_liste).")");
						}
						
						//effacer les anciens articles/abo
						spip_query("DELETE FROM spip_articles WHERE id_article ="._q($id_article));
						spip_query("DELETE FROM spip_auteurs_articles WHERE id_article ="._q($id_article));
			
						//manquent les courriers
					}
				}
				ecrire_meta('spiplistes_version',$current_version=$version_base,'non');
			}
			if ($current_version<1.92){
				echo "SpipListes Maj 1.92<br />";
				spip_query("ALTER TABLE spip_listes ADD titre_message varchar(255) NOT NULL default '';");
				spip_query("ALTER TABLE spip_listes ADD pied_page longblob NOT NULL;");
				ecrire_meta('spiplistes_version', $current_version=1.92);
			}
			if ($current_version<1.94){
				echo "SpipListes Maj 1.94<br />";
				include_spip('base/abstract_sql');
				if (($res=spip_query("SELECT id_auteur FROM spip_auteurs_mod_listes"))
					AND (!spip_fetch_array($res))
				  AND ($desc = spip_abstract_showtable("spip_abonnes_listes", '', true))
				  AND isset($desc['field']['id_auteur'])) {
					spip_query("DROP TABLE spip_auteurs_mod_listes"); // elle vient d'etre cree par un creer_base inopportun
					spip_query("DROP TABLE spip_auteurs_courriers"); // elle vient d'etre cree par un creer_base inopportun
				}
				spip_query("ALTER TABLE spip_auteurs_listes RENAME spip_auteurs_mod_listes;");
				spip_query("ALTER TABLE spip_abonnes_listes RENAME spip_auteurs_listes;");
				spip_query("ALTER TABLE spip_abonnes_courriers RENAME spip_auteurs_courriers;");
				ecrire_meta('spiplistes_version', $current_version=1.94);
			}
			if ($current_version<1.95){
				echo "SpipListes Maj 1.95<br />";
				include_spip('base/abstract_sql');
				spip_query("ALTER TABLE spip_auteurs_courriers ADD etat varchar(5) NOT NULL default '' AFTER statut");
				ecrire_meta('spiplistes_version', $current_version=1.95);
			}
			ecrire_metas();
		}
	}
	
	function spiplistes_vider_tables() {
		include_spip('base/agenda_evenements');
		include_spip('base/abstract_sql');
		// suppression du champ evenements a la table spip_groupe_mots
		spip_query("DROP TABLE spip_courriers");
		spip_query("DROP TABLE spip_listes");
		spip_query("DROP TABLE spip_auteurs_courriers");
		spip_query("DROP TABLE spip_auteurs_listes");
		spip_query("DROP TABLE spip_auteurs_mod_listes");
		effacer_meta('spiplistes_version');
		ecrire_metas();
	}
	
	function spiplistes_install($action){
		$version_base = $GLOBALS['spiplistes_version'];
		switch ($action){
			case 'test':
				return (isset($GLOBALS['meta']['spiplistes_version']) 
				  AND ($GLOBALS['meta']['spiplistes_version']>=$version_base));
				break;
			case 'install':
				spiplistes_verifier_base();
				break;
			case 'uninstall':
				spiplistes_vider_tables();
				break;
		}
	}	
?>